<?php

namespace Drupal\Tests\presspatron\Functional\Block;

use Drupal\Tests\block\Functional\BlockTestBase;

/**
 * Tests basic block functionality.
 *
 * @group Block
 */
class BlockTest extends BlockTestBase {

  /**
   * Modules to install.
   *
   * @var array
   */
  public static $modules = ['block', 'presspatron'];

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'classy';

  /**
   * Tests block visibility.
   */
  public function testBannerBlockVisibility() {
    $block_name = 'presspatron_banner';
    $title = $this->randomMachineName(8);
    $default_theme = $this->config('system.theme')->get('default');
    $edit = [
      'id' => strtolower($this->randomMachineName(8)),
      'region' => 'sidebar_first',
      'settings[label]' => $title,
      'settings[label_display]' => TRUE,
    ];
    $this->drupalGet('admin/structure/block/add/' . $block_name . '/' . $default_theme);

    $this->drupalPostForm(NULL, $edit, t('Save block'));
    $this->assertText('The block configuration has been saved.', 'Block was saved');

    $this->drupalGet('');
    $this->assertText($title, 'Block was displayed on the front page.');
    $this->assertSession()->elementExists('css', 'div#pp-banner');
  }

  /**
   * Tests block visibility.
   */
  public function testButtonBlockVisibility() {
    $block_name = 'presspatron_button';
    $title = $this->randomMachineName(8);
    $default_theme = $this->config('system.theme')->get('default');
    $edit = [
      'id' => strtolower($this->randomMachineName(8)),
      'region' => 'sidebar_first',
      'settings[label]' => $title,
      'settings[label_display]' => TRUE,
    ];
    $this->drupalGet('admin/structure/block/add/' . $block_name . '/' . $default_theme);

    $this->drupalPostForm(NULL, $edit, t('Save block'));
    $this->assertText('The block configuration has been saved.', 'Block was saved');

    $this->drupalGet('');
    $this->assertText($title, 'Block was displayed on the front page.');
    $this->assertSession()->elementExists('css', 'div.pp-donate-button');
  }

}
